#[doc = "Register `EVRSTAT` reader"]
pub type R = crate::R<EVRSTAT_SPEC>;
#[doc = "Field `OV13` reader - Regulator Overvoltage for 1.3 V"]
pub type OV13_R = crate::BitReader<OV13_A>;
#[doc = "Regulator Overvoltage for 1.3 V\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq, Eq)]
pub enum OV13_A {
    #[doc = "0: No overvoltage condition"]
    VALUE1 = 0,
    #[doc = "1: Regulator is in overvoltage"]
    VALUE2 = 1,
}
impl From<OV13_A> for bool {
    #[inline(always)]
    fn from(variant: OV13_A) -> Self {
        variant as u8 != 0
    }
}
impl OV13_R {
    #[doc = "Get enumerated values variant"]
    #[inline(always)]
    pub const fn variant(&self) -> OV13_A {
        match self.bits {
            false => OV13_A::VALUE1,
            true => OV13_A::VALUE2,
        }
    }
    #[doc = "No overvoltage condition"]
    #[inline(always)]
    pub fn is_value1(&self) -> bool {
        *self == OV13_A::VALUE1
    }
    #[doc = "Regulator is in overvoltage"]
    #[inline(always)]
    pub fn is_value2(&self) -> bool {
        *self == OV13_A::VALUE2
    }
}
impl R {
    #[doc = "Bit 1 - Regulator Overvoltage for 1.3 V"]
    #[inline(always)]
    pub fn ov13(&self) -> OV13_R {
        OV13_R::new(((self.bits >> 1) & 1) != 0)
    }
}
#[doc = "EVR Status Register\n\nYou can [`read`](crate::generic::Reg::read) this register and get [`evrstat::R`](R).  See [API](https://docs.rs/svd2rust/#read--modify--write-api)."]
pub struct EVRSTAT_SPEC;
impl crate::RegisterSpec for EVRSTAT_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [`evrstat::R`](R) reader structure"]
impl crate::Readable for EVRSTAT_SPEC {}
#[doc = "`reset()` method sets EVRSTAT to value 0"]
impl crate::Resettable for EVRSTAT_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
